--- UNCHECKED CONVERSION
with UNCHECKED_CONVERSION;

--- SEQUENTIAL INPUT/OUTPUT
with SEQUENTIAL_IO;
with DIRECT_IO;

--- TEXT INPUT/OUTPUT

with TEXT_IO;
with Ada.Exceptions;


procedure ADA_WRITE_TEST is

   File_Create_Error : exception;
   File_Write_Error  : exception;
   File_Close_Error  : exception;

   package FULL_INT_IO is new SEQUENTIAL_IO(INTEGER);
   package INTEGER_IO is new TEXT_IO.INTEGER_IO(INTEGER);

   Data_File : FULL_INT_IO.File_Type;



   procedure Open_File_Write (File_Name : in STRING) is
   begin
      FULL_INT_IO.Create (Data_File, FULL_INT_IO.Out_File, File_Name);
   exception
      when Error : others =>
         raise File_Create_Error;
   end Open_File_Write;




   procedure Close_File_Write is
   begin
      FULL_INT_IO.Close(Data_File);
   exception
      when Error : others =>
         raise File_Close_Error;
   end Close_File_Write;



   procedure Write_Full_Integer(DWORD : in INTEGER) is
   begin
      FULL_INT_IO.Write(Data_File, DWORD);

   exception
      when Error : others =>

         Text_IO.PUT_LINE(Ada.Exceptions.Exception_Name(Error));
         Text_IO.PUT_LINE(Ada.Exceptions.Exception_Message(Error));

         raise File_Write_Error;
   end Write_Full_Integer;


begin

    Text_IO.PUT_LINE("Opening the file");

    Open_File_Write("ada_write_test.dat");

    Text_IO.PUT_LINE("Writing the full integer");

    Write_Full_Integer(123456);

    Text_IO.PUT_LINE("Closing the file");

    Close_File_Write;

    Text_IO.PUT_LINE("GOODBYE!");

exception

   when Error : others =>

      Text_IO.Put_Line(Ada.Exceptions.Exception_Name(Error));
      Text_IO.Put_Line(Ada.Exceptions.Exception_Message(Error));

end ADA_WRITE_TEST;
